#ifndef ___Matrice4_H__
#define ___Matrice4_H__

#include <math.h>
#include <iostream>
#include "Vecteur4.h"
#include "vecteur3f.h"
/** @brief Classe qui permet de gérer des matrice 4×4 (pour OpenGl 3.1), et le meilleur c'est qu'on est obliger d'utiliser des float parce que la fonction glUniformMatrix4dv n'existe pas dans la lib de opengl 3.1 (enfin mesa 7.11) mais existe dans le .h, donc une erreur au linkage mais pas pour les include, BANDE DE BOULETS!!!!!!!!!
*/

void produitVectoriel(float & x, float & y, float & z, float x1, float y1, float z1, float x2, float y2, float z2);
void normaliseVecteur(float & x, float & y, float & z);

class Matrice4{
	public:
		Matrice4();
		Matrice4(const Vecteur4 & v1, const Vecteur4 & v2, const Vecteur4 & v3, const Vecteur4 & v4);
		Matrice4(float x1, float y1, float z1, float t1,
			float x2, float y2, float z2, float t2,
			float x3, float y3, float z3, float t3,
			float x4, float y4, float z4, float t4
		);
		Matrice4(const Matrice4 & other);
		virtual ~Matrice4();
		
		void setMatrice4(const Vecteur4 & v1, const Vecteur4 & v2, const Vecteur4 & v3, const Vecteur4 & v4);
		void setMatrice4(float x1, float y1, float z1, float t1,
			float x2, float y2, float z2, float t2,
			float x3, float y3, float z3, float t3,
			float x4, float y4, float z4, float t4
		);
		
		void loadIdentity();
		void loadNull();
		void translated(float x, float y, float z);
		void scale(float x, float y, float z);
		void rotateRad(float angle, float x, float y, float z);
		void rotateDeg(float angle, float x, float y, float z);
		void perspectiveRad(float angle, float ratio, float near, float far);
		void perspectiveDeg(float angle, float ratio, float near, float far);
		void lookAt(float eyeX, float eyeY, float eyeZ, float centerX, float centerY, float centerZ, float upX, float upY, float upZ);
		void lookAt(const Vecteur3f & eye, const Vecteur3f & center, const Vecteur3f & up);
		void lookAt(const Vecteur3f & position, const Vecteur3f & visee, const Vecteur3f & planDroit, const Vecteur3f & up);
		
		bool push();
		bool pop();
		void depiler();
		
		float * getValue() const;
		
		//Les opérateurs de la classe Matrice4
		Matrice4 & operator = (const Matrice4 & other);
		Matrice4 & operator - ();
		Matrice4 & operator -= (const Matrice4 & other);
		Matrice4 & operator += (const Matrice4 & other);
		Matrice4 & operator *= (const Matrice4 & other);
		Matrice4 & operator *= (float nb);
		Matrice4 & operator /= (float nb);

		//Les opérateurs amis de la classe Matrice4
		friend bool operator == (const Matrice4 & other1, const Matrice4 & other2);
		friend bool operator != (const Matrice4 & other1, const Matrice4 & other2);
		friend Matrice4 operator + (const Matrice4 & other1, const Matrice4 & other2);
		friend Matrice4 operator - (const Matrice4 & other1, const Matrice4 & other2);
		friend Matrice4 operator * (const Matrice4 & other1, const Matrice4 & other2);
		friend Matrice4 operator * (float nb, const Matrice4 & other1);
		friend Matrice4 operator * (const Matrice4 & other1, float nb);
		friend Vecteur4 operator * (const Matrice4 & matrice, const Vecteur4 & vecteur);
		friend Matrice4 operator / (const Matrice4 & other1, float nb);
		
		friend std::ostream & operator << (std::ostream & out, const Matrice4 & matrice);
		
	private:
		void initialisationMatrice4(const Vecteur4 & v1, const Vecteur4 & v2, const Vecteur4 & v3, const Vecteur4 & v4);
		void initialisationMatrice4(float x1, float y1, float z1, float t1,
						float x2, float y2, float z2, float t2,
						float x3, float y3, float z3, float t3,
						float x4, float y4, float z4, float t4
		);
		void createMatrice4();
		void copyMatrice4(const Matrice4 & other);
		
		float * p_mat;
		Matrice4 *p_sauvegardePrecedente;
		
};

///definition d'une Matrice NULLE
extern const Matrice4 MAT4_NULL;
///definition d'une Matrice IDENTITÉ
extern const Matrice4 MAT4_ID;

#endif //classe Matrice4

